/* Sistemas Integrados TECNISA

Nome: 01MZ_GERTRGS_DTULTATU_HABILIDADE.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela HABILIDADE

Criao:
21/04/2007 Ronald Reis
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_HABILIDADE' and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
  DROP TRIGGER DTULTATU_HABILIDADE
  GO

CREATE TRIGGER DTULTATU_HABILIDADE
ON HABILIDADE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'HABILIDADE', 'CDHABILIDADE=' + CDHABILIDADE+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE HABILIDADE
      SET  DTULTATUHABI = GETDATE()
      FROM INSERTED
      WHERE ISNULL(HABILIDADE.CDHABILIDADE,0) = ISNULL(INSERTED.CDHABILIDADE,0);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_HABILIDADE','4.11.018';
GO